/*
			Cxg쓮^Cuic`hc`knrj

							1994/10/31  a
*/

#define NODEBUG 1

#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "environ.h"

const ENV_BK_COLOR = CYAN;							/*	wiF	*/


void box(int x1, int y1, int x2, int y2)
{
	line(x1, y1, x2, y1);
	line(x2, y1, x2, y2);
	line(x2, y2, x1, y2);
	line(x1, y2, x1, y1);
}


/*	яo	*/
void sBox(int x1, int y1, int x2, int y2)
{
	setcolor(WHITE);
	line(x1, y1, x2, y1);
	line(x1, y1, x1, y2);
	setcolor(BLACK);
	line(x2, y2, x1, y2);
	line(x2, y2, x2, y1);
}


/*	񂾔	*/
void cBox(int x1, int y1, int x2, int y2)
{
	setcolor(BLACK);
	line(x1, y1, x2, y1);
	line(x1, y1, x1, y2);
	setcolor(WHITE);
	line(x2, y2, x1, y2);
	line(x2, y2, x2, y1);
}



/*			OBJ NX ̃o֐Q			*/

OBJ::~OBJ(void)
{
	OBJList *child = pObj, *NextP;
	while (child != NULL) {
		NextP = child->Next;
		delete child;
		child = NextP;
	}
}


void OBJ::Write(void)
{
	WriteFlag = 1;

	OBJList *child = pObj;
	while (child != NULL) {
		child->Obj->Write();
		child = child->Next;
	}
}

void OBJ::Erase(void)
{
	WriteFlag = 0;

	OBJList *child = pObj;
	while (child != NULL) {
		child->Obj->Erase();
		child = child->Next;
	}
}

void OBJ::SetPoint(int x, int y)
{
	MovePoint(x - Bx, y - By);
}

void OBJ::MovePoint(int x, int y)
{
	int WF = WriteFlag;
	if (WF)
		Erase();
	Bx += x;
	By += y;

	//	`ChIuWFNg𓮂
	OBJList *child = pObj;
	while (child != NULL) {
		child->Obj->MovePoint(x, y);
		child = child->Next;
	}

	if (WF)
		Write();
}

int OBJ::XyCheck(int x, int y)
{
	if (Bx == x && By == y)
		return 1;
	else
		return 0;
}

int OBJ::Procedure(EventType *evt)
{
	if (pObj == NULL)
		return C_Continue;
	return ChildProcedure(evt);
}

/*	`ChIuWFNg̃vVW[s	*/
int OBJ::ChildProcedure(EventType *evt)
{
	int MaxRetCode = C_Continue;
	int retcode;

	OBJList *child = pObj;
	while (child != NULL) {
		retcode = child->Obj->Procedure(evt);
		if (retcode > MaxRetCode)
			MaxRetCode = retcode;
		child = child->Next;
	}
	return MaxRetCode;
}

/*	`ChIuWFNg𒣂tiNj	*/
void OBJ::Paste(OBJ *child, int x, int y)
{
	if (endP == NULL) {
		pObj = new OBJList;
		if (pObj == NULL)
			return;
		endP = pObj;
	}
	else {
		endP->Next = new OBJList;
		if (endP->Next == NULL)
			return;
		endP = endP->Next;
	}
	endP->Obj = child;
	endP->Next = NULL;
	child->SetPoint(Bx + x, By + y);

	if (WriteFlag != 0)
		child->Write();
}



/*			FREE_AREA NX̃o֐Q		*/


FREE_AREA::~FREE_AREA(void)
{
	if (screen != NULL)
		free(screen);
}


int FREE_AREA::Procedure(EventType *evt)
{
	int r1 = C_Continue, r2;
	r2 = OBJ::Procedure(evt);
	if (Proc != NULL && (CallProcMode == EM_EVERY || evt->code != EV_IDLE))
			r1 = Proc(evt);

	return (r1 > r2) ? r1 : r2;
}

void FREE_AREA::Write(void)
{
	setfillstyle(SOLID_FILL, LIGHTGRAY);
	setlinestyle(SOLID_LINE, 0xffff, DARKGRAY);
	setcolor(WHITE);
	mouseoff();
	bar(0, 0, Xsize, Ysize);
	box(0, 0, Xsize, Ysize);
	mouseon();
	ScLoad();
	OBJ::Write();
}

void FREE_AREA::Erase(void)
{
	OBJ::Erase();

	setfillstyle(SOLID_FILL, ENV_BK_COLOR);
	mouseoff();
	bar(0, 0, Xsize, Ysize);
	mouseon();
}

/*	IuWFNgĂȂԂɂ	*/
void FREE_AREA::Clear(void)
{
	if (WriteFlag) {
        mouseoff();
        setfillstyle(SOLID_FILL, LIGHTGRAY);
		bar(1, 1, Xsize - 1, Ysize - 1);
        if (screen)
        	ScSave();
		mouseon();
	}
}

/*	TCYύX	*/
void FREE_AREA::SetSize(int sx, int sy)
{
	int WF = WriteFlag;

	if (WF)
		Erase();

	Xsize = sx;
	Ysize = sy;

	if (Xsize < 50)
		Xsize = 50;
	if (Ysize < 32)
		Ysize = 32;

	if (WF)
		Write();
}

/*	`Ăeۑ	*/
void FREE_AREA::ScSave(void)
{
	if (screen == NULL) {
		screen = malloc(imagesize(0, 0, Xsize, Ysize));
	}
	if (screen == NULL) {
		printf("\a");
		return;
	}
	mouseoff();
	getimage(0, 0, Xsize, Ysize, screen);
	mouseon();
}

/*  ۑĂe𕜌	*/
void FREE_AREA::ScLoad(void)
{
	if (screen == NULL)
		return;
/*
	int x1, y1, x2, y2, f = 0;

	if (getBx() < ClipLeft())
		f = 1, x1 = getBx();
	else
		x1 = ClipLeft();
	if (getBy() < ClipTop())
		f = 1, y1 = getBy();
	else
		y1 = ClipTop();

	if (getEx() > ClipRight())
		f = 1, x2 = getEx();
	else
		x2 = ClipLeft();
	if (getEy() > ClipBottom())
		f = 1, y2 = getEy();
	else
		y2 = ClipBottom();
*/

	mouseoff();
	putimage(0, 0, screen, COPY_PUT);
	mouseon();
//	if (f != 0)
//		SetClip(x1, y1, x2, y2);
}

void FREE_AREA::PutImage(int x, int y)
{
	if (screen == NULL)
		return;
	mouseoff();
	::putimage(x, y, screen, COPY_PUT);
	mouseon();
}



/*			FREE_AREAs NX̃o֐		*/

void FREE_AREAs::Write(void)
{
	FREE_AREA::Write();
	mouseoff();
	sBox(0, 0, Xsize, Ysize);
	mouseon();
}



/*			FREE_AREAc NX̃o֐		*/

void FREE_AREAc::Write(void)
{
	FREE_AREA::Write();
	mouseoff();
	cBox(0, 0, Xsize, Ysize);
	mouseon();
}



/*			BOARD NX̃o֐Q		*/

void BOARD::Write(void)
{
	FREE_AREAs::Write();
	mouseoff();
	sBox(1, 17, Xsize - 1, Ysize - 1);
	cBox(4, 17 + 3, Xsize - 4, Ysize - 4);
	mouseon();
	WriteTitle();
}

/*	^Cgo[`	*/
void BOARD::WriteTitle(void)
{
	setlinestyle(SOLID_LINE, 0xffff, DARKGRAY);
	setfillstyle(SOLID_FILL, TitleColor);
	setgtextjustify(CENTER_TEXT, CENTER_TEXT);
	mouseoff();
	bar(0, 0, Xsize, 16);
	sBox(0, 0, Xsize, 16);
	sBox(1, 1, Xsize - 1, 16 - 1);

	setcolor(BLACK);
	gtextxy(Xsize / 2 + 1, 8 + 1, Title);
	setcolor(WHITE);
	gtextxy(Xsize / 2, 8, Title);

	mouseon();
	setgtextjustify(LEFT_TEXT, TOP_TEXT);
}

/*	^Cgo[̐FݒiftHg LIGHTBLUEj	*/
void BOARD::SetTitleColor(int color)
{
	TitleColor = color;
	if (WriteFlag)
		WriteTitle();
}

/*	^Cgݒ	*/
void BOARD::SetTitle(char *title)
{
	strncpy(Title, title, 79);
	Title[79] = '\0';
	if (WriteFlag)
		WriteTitle();
}



/*			BUTTON NX̃o֐Q		*/

/*	펞iĂȂƂj̃{^`	*/
void BUTTON::Write(void) {
	FREE_AREA::Write();
	setgtextjustify(CENTER_TEXT, CENTER_TEXT);
	mouseoff();
	setcolor(WHITE);
	gtextxy(Xsize / 2 + 1, Ysize / 2 + 1, Name);
	setcolor(BLACK);
	gtextxy(Xsize / 2, Ysize / 2, Name);

	sBox(0, 0, Xsize, Ysize);
	sBox(1, 1, Xsize - 1, Ysize - 1);

	mouseon();
	setgtextjustify(LEFT_TEXT, TOP_TEXT);
	WriteFlag = 1;
}

/*	ĂƂ̃{^`	*/
void BUTTON::Write2(void) {
	FREE_AREA::Write();
	setgtextjustify(CENTER_TEXT, CENTER_TEXT);
	mouseoff();
	setcolor(WHITE);
	gtextxy(Xsize / 2 + 2, Ysize / 2 + 2, Name);
	setcolor(BLUE);
	gtextxy(Xsize / 2 + 1, Ysize / 2 + 1, Name);
	cBox(0, 0, Xsize, Ysize);
	mouseon();
	setgtextjustify(LEFT_TEXT, TOP_TEXT);
	WriteFlag = 2;
}

int BUTTON::Procedure(EventType *evt)
{
	LastState = State;
    if (isMouseEvent(evt->code))
		State = (evt->MouseLKey && XyCheck(evt->MouseX, evt->MouseY));

    if (evt->code != EV_IDLE) {
		if (State && WriteFlag == 1 /*PushMoment()*/)
			Write2();
		else if (!State && WriteFlag == 2 /*FreeMoment()*/)
			Write();
    }
	return FREE_AREA::Procedure(evt);
}



/*			StrMessage NX̃o֐Q		*/

void StrMessage::Write(void) {
	int maxX = (Xsize - 16) / 8;
	if (maxX > 79)
		maxX = 79;
	char buf[80];
	strncpy(buf, Str, 79);
	buf[maxX] = '\0';

	FREE_AREAc::Write();
	setgtextjustify(LEFT_TEXT, CENTER_TEXT);
	mouseoff();
	setcolor(WHITE);
	gtextxy(8, Ysize / 2, buf);
	setcolor(BLACK);
	gtextxy(8 + 1, Ysize / 2 + 1, buf);
	mouseon();
	setgtextjustify(LEFT_TEXT, TOP_TEXT);
}


void StrMessage::SetStr(const char *str)
{
	strncpy(Str, str, 79);
	Str[79] = '\0';
	if (WriteFlag)
		Write();
}


static MOUSE_SPEED = 5;							/*	}EXXs[h	*/
static BUTTON MOUSE_UP_B(0, 0, "Up");			
static BUTTON MOUSE_DOWN_B(0, 0, "Down");
BOARD SysSet(0, 0, 200, 150, "System Setting");

static void MouseSpeedWrite(void)
{
	mouseoff();
	setcolor(BLACK);
	gtextxy(SysSet.getBx() + 16, SysSet.getBy() + 20, "mouse speed");
	SysSet.box(49, 59, 151, 81);
    setfillstyle(SOLID_FILL, LIGHTGRAY);
	SysSet.bar(50, 60, 150, 80);

    if (MOUSE_SPEED < 3)
		setfillstyle(SOLID_FILL, LIGHTRED);
    else if (MOUSE_SPEED < 7)
		setfillstyle(SOLID_FILL, LIGHTGREEN);
    else
		setfillstyle(SOLID_FILL, LIGHTBLUE);

	SysSet.bar(50, 60, 50 + (10 - MOUSE_SPEED) * 10, 80);
	mouseon();
}


int MouseUpProc(EventType *)
{
	if (MOUSE_UP_B.FreeMoment() && MOUSE_SPEED > 0) {
		MOUSE_SPEED--;
		mousespeed(MOUSE_SPEED + 1);
		MouseSpeedWrite();
	}
	return C_Continue;
}


int MouseDownProc(EventType *)
{
	if (MOUSE_DOWN_B.FreeMoment() && MOUSE_SPEED  < 10) {
		MOUSE_SPEED++;
		mousespeed(MOUSE_SPEED + 1);
		MouseSpeedWrite();
	}
	return C_Continue;
}

int SysSetProc(EventType *evt)
{
	if (evt->code == EV_UPDATE) {
		MouseSpeedWrite();
	}
	return C_Continue;
}


void SysSetInit(void)
{
	SysSet.SetProc(SysSetProc);
	SysSet.Paste(&MOUSE_UP_B, 100, 100);
	SysSet.Paste(&MOUSE_DOWN_B, 20, 100);
	MOUSE_UP_B.SetProc(MouseUpProc);
	MOUSE_DOWN_B.SetProc(MouseDownProc);
	RegistObj(&SysSet);
	mousespeed(MOUSE_SPEED + 1);
}



unsigned char ScanCh(void)
{
	if (KbHit())
		return (unsigned char)GetCh();
	return 0;
}



/*	Cxg^̃Xg	*/
class EVENT_QUEUE {
	EventType Event;
	EVENT_QUEUE *Next;
public:
	EVENT_QUEUE(void) {	Next = NULL; }
	EVENT_QUEUE(EventType *evt,EVENT_QUEUE *next = NULL) {
		Event = *evt;
		Next = next;
	}
	void SetEvent(EventType *evt) {
		Event = *evt;
	}
	void GetEvent(EventType *evt) {
		*evt = Event;
	}
	void SetNext(EVENT_QUEUE *next) { Next = next; }
	void InsNext(EVENT_QUEUE *next);
	EVENT_QUEUE *GetNext(void) { return Next; }
};

void EVENT_QUEUE::InsNext(EVENT_QUEUE *next)
{
	EVENT_QUEUE *work;
	work = Next;
	Next = next;
	if (next != NULL)
		next->SetNext(work);
}


/*	̃Xg\ŃL[\	*/
/*	ŏ͉Ȃ	*/
EVENT_QUEUE *MsgOut = NULL;
EVENT_QUEUE *MsgIn = NULL;

void SetMsgQueue(EventType *evt)
{
	EVENT_QUEUE *work;
	if (MsgIn == NULL) {	/*	ԍŏ̌ĂяoɎs	*/
		MsgIn = new EVENT_QUEUE;
		if (MsgIn == NULL)
			return;
		MsgIn->SetNext(MsgIn);
		MsgOut = MsgIn;
	}
	MsgIn->SetEvent(evt);
	if (MsgIn->GetNext() == MsgOut) {
		work = new EVENT_QUEUE(evt);
		if (work == NULL)
			return;
		MsgIn->SetNext(work);
		work->SetNext(MsgOut);
	}
	MsgIn = MsgIn->GetNext();
}


void GetMsgQueue(EventType *evt)
{
	if (MsgOut == MsgIn) {
		evt->code = EV_IDLE;
	}
	else {
		MsgOut->GetEvent(evt);
		MsgOut = MsgOut->GetNext();
	}
}


void MakeEvent(void)
{
	static EventType Evt = { 0, 0, 0, 0, 0 }, LastEvt;
	/*	n[hEGȀԂ擾	*/
	LastEvt = Evt;
	Evt.code = ScanCh();

	/*	n[hEGȀԂɂăCxgݒ肷	*/
	if (Evt.code != EV_IDLE)	//	L[̓Cxg̐ݒ
		SetMsgQueue(&Evt);

	getmousexy(&Evt.MouseX, &Evt.MouseY);
	if (LastEvt.MouseX != Evt.MouseX || LastEvt.MouseY != Evt.MouseY) {
		Evt.code = EV_MSMOVE;	//	}EẌړ
		SetMsgQueue(&Evt);
	}

	Evt.MouseLKey = mouselkey();
	if (LastEvt.MouseLKey != Evt.MouseLKey) {
		Evt.code = Evt.MouseLKey ? EV_MSLDOWN : EV_MSLUP; //}EX̍L[
		SetMsgQueue(&Evt);
	}

	Evt.MouseRKey = mouserkey();
	if (LastEvt.MouseRKey != Evt.MouseRKey) {
		Evt.code = Evt.MouseRKey ? EV_MSRDOWN : EV_MSRUP; //}EX̉EL[
		SetMsgQueue(&Evt);
	}
}


/*	EChEVXe̊	*/
const OBJ_MAX = 50;
BOARD *MAIN_OBJ[OBJ_MAX];
int O_Count;

void ObjWrite(int start = 0, int end = OBJ_MAX)
{
	EventType evt;
	evt.code = EV_UPDATE;
	end = (end > O_Count) ? (O_Count - 1) : (end - 1);
	for (int i = end; i >= start; i--) {
		MAIN_OBJ[i]->Write();
		MAIN_OBJ[i]->Procedure(&evt);
	}
}


void ObjErase(void)
{
	for (int i = 0; i < O_Count; i++)
		MAIN_OBJ[i]->Erase();
}


void ActiveObjWrite(void)
{
	EventType evt;
	evt.code = EV_UPDATE;
	MAIN_OBJ[0]->Write();
	MAIN_OBJ[0]->Procedure(&evt);
}


void SetActiveObj(int num)
{
	BOARD *Work = MAIN_OBJ[num];
	EventType evt;
	evt.code = EV_NOACTIVE;
	MAIN_OBJ[0]->Procedure(&evt);
	MAIN_OBJ[0]->SetTitleColor(LIGHTGRAY);
	for (int i = num - 1; i >= 0; i--)
		MAIN_OBJ[i + 1] = MAIN_OBJ[i];
	MAIN_OBJ[0] = Work;
	ActiveObjWrite();
	MAIN_OBJ[0]->SetTitleColor();
	evt.code = EV_ACTIVE;
	MAIN_OBJ[0]->Procedure(&evt);
}


void MoveActiveObj(int x, int y)
{
	EventType evt;
	BOARD &AcObj = *(MAIN_OBJ[0]);
	evt.code = EV_NOACTIVE;
	AcObj.Procedure(&evt);
	AcObj.Erase();
//	SetClip(AcObj.getBx(), AcObj.getBy(), AcObj.getEx(), AcObj.getEy());
	ObjWrite(1);
//	SetClip(0, 0, getmaxx(), getmaxy());
	AcObj.SetPoint(x, y);
	ActiveObjWrite();
	evt.code = EV_ACTIVE;
	AcObj.Procedure(&evt);
}


void RegistObj(BOARD *OBJ)
{
    int i;
    for (i = 0; i < O_Count; i++) {
    	if (MAIN_OBJ[i] == OBJ) {
			SetActiveObj(i);
            return;
        }
    }

	if (O_Count >= OBJ_MAX)
		return;
	O_Count++;
	for (i = O_Count - 1; i > 0; i--)
		MAIN_OBJ[i] = MAIN_OBJ[i - 1];
	MAIN_OBJ[0] = OBJ;
	MAIN_OBJ[0]->SetTitleColor();
	if (O_Count >= 2) {
		MAIN_OBJ[1]->SetTitleColor(LIGHTGRAY);
		if (MAIN_OBJ[1]->GetWriteFlag())
            ActiveObjWrite();
    }
}


void DeleteActiveObj(void)
{
    int WriteFlag;
	if (O_Count <= 0)
		return;
	EventType evt;
	evt.code = EV_NOACTIVE;
	MAIN_OBJ[0]->Procedure(&evt);
	if (MAIN_OBJ[0]->GetWriteFlag()) {
        WriteFlag = 1;
    	ObjErase();
    }
	for (int i = 0; i < O_Count - 1; i++)
		MAIN_OBJ[i] = MAIN_OBJ[i + 1];
	O_Count--;
    if (WriteFlag != 0 && O_Count > 0)
    	ObjWrite();
	MAIN_OBJ[0]->SetTitleColor();
	evt.code = EV_ACTIVE;
	MAIN_OBJ[0]->Procedure(&evt);
}


/*	KvȂANeBuȃIuWFNgANeBuȏԂɐ؂ւ	*/
void ActiveCheck(EventType *evt)
{
	if (evt->code == EV_MSLDOWN || evt->code == EV_MSRDOWN) {
		int st;
		for (int i = 0; i < O_Count; i++) {
			st = MAIN_OBJ[i]->XyCheck(evt->MouseX, evt->MouseY);
			if (st)
				break;
		}
		if (st && i != 0) {
			SetActiveObj(i);
		}
	}
}


/*	XN[͂ݏoȂ悤 box `	*/
void BoardOutline(int x1, int y1, int x2, int y2)
{
	int Xmax = getmaxx();
	int Ymax = getmaxy();
    int Xoffset = 0;
    int Yoffset = 0;

    if (x1 < 0)
    	Xoffset = -x1;
    else if (x2 > Xmax)
    	Xoffset = Xmax - x2;

    if (y1 < 0)
    	Yoffset = -y1;
    else if (y2 > Ymax)
    	Yoffset = Ymax - y2;

    x1 += Xoffset;
    y1 += Yoffset;
    x2 += Xoffset;
    y2 += Yoffset;

    box(x1, y1, x2, y2);
}


/*	KvȂANeBuȃIuWFNgړ	*/
void BOARDMoveCheck(EventType *evt)
{
	BOARD &AcObj = *(MAIN_OBJ[0]);
	unsigned LineMask = 0xf0f0;
	if (AcObj.XyCheckTitle(evt->MouseX, evt->MouseY) &&
											evt->code == EV_MSLDOWN) {
		int OffX = evt->MouseX - AcObj.getBx();
		int OffY = evt->MouseY - AcObj.getBy();
		int	lx, ly;		//	ЂƂÕ}EX̍W
		int initX = lx = evt->MouseX;	//	}EX̂wW̏l
		int initY = ly = evt->MouseY;	//	}EX̂xW̏l
		setwritemode(XOR_PUT);
		setcolor(LIGHTBLUE);
		mouseoff();
		setlinestyle(USERBIT_LINE, LineMask, 1);
		BoardOutline(evt->MouseX - OffX, evt->MouseY - OffY,
						evt->MouseX - OffX + AcObj.getSx(),
						evt->MouseY - OffY + AcObj.getSy());
		mouseon();
		while (evt->MouseLKey) {
			mouseoff();
			setlinestyle(USERBIT_LINE, LineMask, 1);
			BoardOutline(lx - OffX, ly - OffY, lx - OffX + AcObj.getSx(),
											ly - OffY + AcObj.getSy());
			LineMask = (LineMask >> 1) | (LineMask << 15);
			setlinestyle(USERBIT_LINE, LineMask, 1);
			BoardOutline(evt->MouseX - OffX, evt->MouseY - OffY,
							evt->MouseX - OffX + AcObj.getSx(),
							evt->MouseY - OffY + AcObj.getSy());
			mouseon();
			lx = evt->MouseX;
			ly = evt->MouseY;
            GetMsgQueue(evt);
            if (evt->code == EV_IDLE) {
	            MakeEvent();
    	        GetMsgQueue(evt);
            }
			Interval(25);
		}
		mouseoff();
		setlinestyle(USERBIT_LINE, LineMask, 1);
		BoardOutline(lx - OffX, ly - OffY, lx - OffX + AcObj.getSx(),
									ly - OffY + AcObj.getSy());
		mouseon();
		setlinestyle(SOLID_LINE, LineMask, 1);
		setwritemode(COPY_PUT);

		if (evt->MouseX - OffX < 0)
			evt->MouseX = OffX + 0;
		if (evt->MouseY - OffY < 0)
			evt->MouseY = OffY + 0;
		if (evt->MouseX - OffX + AcObj.getSx() > getmaxx())
			evt->MouseX = getmaxx() - AcObj.getSx() + OffX;
		if (evt->MouseY - OffY + AcObj.getSy() > getmaxy())
			evt->MouseY = getmaxy() - AcObj.getSy() + OffY;

		if (evt->MouseX != initX || evt->MouseY != initY)
			MoveActiveObj(evt->MouseX - OffX, evt->MouseY - OffY);
	}
}


void SysControl(void) {
	int i, retcode = C_Continue, MaxRetcode = C_Continue;
	EventType Evt;

	ObjWrite();
	Evt.code = EV_ACTIVE;
	MAIN_OBJ[0]->Procedure(&Evt);

	Evt.code = EV_START;
	SetMsgQueue(&Evt);

    do {
		do {
			GetMsgQueue(&Evt);

			ActiveCheck(&Evt);
			BOARDMoveCheck(&Evt);

			/*	CxgeIuWFNgɓ`B	*/
			MaxRetcode = MAIN_OBJ[0]->Procedure(&Evt);
			/*	ANeBuȃIuWFNg̓Cxg̎ނ	*/
			if (isActionEvent(Evt.code))
				Evt.code = EV_IDLE;
			for (i = 1; i < O_Count; i++) {
				retcode = MAIN_OBJ[i]->Procedure(&Evt);
                if (retcode > MaxRetcode)
                	MaxRetcode = retcode;
            }
			if (MaxRetcode == C_End)
				break;

    		MakeEvent();
		} while (retcode != C_End);

		Evt.code = EV_END;
		for (i = 0; i < O_Count; i++) {
			retcode = MAIN_OBJ[i]->Procedure(&Evt);
            if (retcode > MaxRetcode)
            	MaxRetcode = retcode;
        }
    } while (MaxRetcode == C_EndCancel);
	ObjErase();
}



void Message(const char *msg)
{
	static void *BackScreen = NULL;
	if (BackScreen == NULL) {
		BackScreen = malloc(imagesize(0, 0, 30 * 8, 32));
		if (BackScreen == NULL) {
			printf("\a");
			return;
		}
	}
	int bx, by;
	bx = getmaxx() / 2 - 30 * 8 / 2;
	by = getmaxy() / 2 - 16;
	mouseoff();
	getimage(bx, by, bx + 30 * 8, by + 32, BackScreen);
	setfillstyle(SOLID_FILL, LIGHTGRAY);
	bar(bx, by, bx + 30 * 8, by + 32);
	sBox(bx, by, bx + 30 * 8, by + 32);
	sBox(bx + 1, by + 1, bx + 30 * 8 - 1, by + 32 - 1);
	cBox(bx + 3, by + 3, bx + 30 * 8 - 3, by + 32 - 3);
	char str[29];
	strncpy(str, msg, 28);
	str[28] = '\0';
	setgtextjustify(CENTER_TEXT, CENTER_TEXT);
	setcolor(BLACK);
	gtextxy(getmaxx() / 2, getmaxy() / 2, str);
	mouseon();
	printf("\a");
	Interval(1400);
	setgtextjustify(LEFT_TEXT, TOP_TEXT);
	mouseoff();
	putimage(bx, by, BackScreen, COPY_PUT);
	mouseon();
	printf("\a");
}


static void UserBreak(int)
{
	TermEnvironment();
	printf("User Break.\a\n");
	printf("compel stop ... Environment System \"DAIDALOS\"");
	exit(EXIT_FAILURE);
}


void InitEnvironment(char *BGI)
{
	signal(SIGINT, UserBreak);
	int gdriver = DETECT, gmode, errorcode;
/*
#ifdef PC98__
	registerbgidriver(PC98_driver);
#else
	registerbgidriver(EGAVGA_driver);
#endif
*/
	initgraph(&gdriver, &gmode, BGI);
	errorcode = graphresult();
	if (errorcode != grOk) {
		printf("Graphics Error\a\n");
		exit(1);
	}
	setfillstyle(SOLID_FILL, ENV_BK_COLOR);
	bar(0, 0, getmaxx(), getmaxy());
//	setfillstyle(SOLID_FILL, WHITE);
//	bar(0, 0, getmaxx(), 15);
//	setcolor(BLACK);
//	line(0, 15, getmaxx(), 15);
//	gtextxy(16, 0, "System  Environment");
	initmouse();
	SysSetInit();
	mouseon();
	InitKb();
}


void TermEnvironment(void)
{
	mouseoff();
	cleardevice();
	closegraph();
	TermKb();
}


unsigned short mp_pen[] = {
	0xf000,	//  
	0xc800,	//      
	0x9400,	//        
	0xb200,	//        
	0x4900,	//            
	0x2480,	//              
	0x1240,	//                
	0x0920,	//              	
	0x0490,	//                	  
	0x0248,	//                      
	0x0124,	//                        
	0x0092, //                          
	0x004c, //                        
	0x0028, //                        
	0x0010, //                        
	0x0000
};


static unsigned short *MOUSE_CURSOR[] = { mp_nomal, mp_bunsyo, mp_pen };
static int MouseCursor = 0;


void SetMouseCursor(int m)
{
	MouseCursor = m;
	setmousecursor(MOUSE_CURSOR[m]);
}


int MouseCursorNo(void)
{
	return MouseCursor;
}


/*  Copyright(C) 1994 a  */
