/*
					菑ʃCu

					1994/10/28  a
*/


#define NODEBUG 1

#define DATA_FILE "chrdata.ace"
#define STD_CHAR_MAX 1024

#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include <limits.h>

#include "bgi.h"
#include "moji.h"
#include "mouselib.h"
#include "vsmi.h"


#define abs(a) ((a >= 0) ? (a) : -(a))

class CharData {
	char Ch;
	CHR_FEATURE Feature;
public:
	CharData(char ch, CHR_FEATURE feature) {
		setData(ch, feature);
	}
	CharData(void) {
		Ch = -1;
	}
	void setData(char ch, CHR_FEATURE feature);
	int comp(CHR_FEATURE data);
	int fOut(FILE *fp);
	int fIn(FILE *fp);
	char Char(void) { return Ch; }
};


void CharData::setData(char ch, CHR_FEATURE feature)
{
	Ch = ch;
	for (int i = 0; i < FeatureSize; i++)
		Feature[i] = feature[i];
}


int CharData::comp(CHR_FEATURE data)
{
	int i, D = 0;
	for (i = 0; i < FeatureSize; i++)
//		D += ((Feature[i] - *(data + i)) * (Feature[i] - *(data + i)));
		D += abs(Feature[i] - *(data + i));
	return D;
}


int CharData::fOut(FILE *fp)
{
	if (fprintf(fp, "%c\t", Ch) == EOF)
		return 1;
	for (int i = 0; i < FeatureSize - 1; i++)
		if (fprintf(fp, "%d,", Feature[i]) == EOF)
			return 1;
	if (fprintf(fp, "%d\n", Feature[FeatureSize - 1]) == EOF)
		return 1;
	return 0;
}


int CharData::fIn(FILE *fp)
{
	char buf[256], c;
	int i, j;
	CHR_FEATURE feature;

	if (fgets(buf, 256, fp) == NULL)
		return 1;
	c = *buf;

	j = 1;
	for (i = 0; i < FeatureSize; i++) {
		while (!isdigit(buf[j])) j++;
		feature[i] = 0;
		while (isdigit(buf[j])) {
			feature[i] *= 10;
			feature[i] += (buf[j] - '0');
			j++;
		}
	}
	setData(c, feature);
	return 0;
}



static CharData *CHR[STD_CHAR_MAX];		/*	W`ւ̃|C^z	*/
static CharCount = 0;					/*	W`̐				*/
static LoadCount = 0;					/*	t@C烍[hꂽ	*/
static CHR_COLOR = WHITE;				/*	OtBbN̐̕F		*/
static char DataFile[FILENAME_MAX] = DATA_FILE;	/*	f[^t@C	*/


int GetCHR_COLOR(void)
{
	return CHR_COLOR;
}


int SetCHR_COLOR(int c)
{
	return (CHR_COLOR = c);
}


void SetCHRDataDir(char *dir)
{
	strncpy(DataFile, dir, FILENAME_MAX - strlen(DataFile) - 1);
	DataFile[FILENAME_MAX - strlen(DataFile) - 1] = '\0';
	int len = strlen(DataFile);
	if (DataFile[len - 1] != '\\' && len > 0)
		strcat(DataFile, "\\");
	strcat(DataFile, DATA_FILE);
}


int SaveCHR(void)
{
	/*	ǂݍ񂾃f[^t@CȂĂȂ	*/
	FILE *fp = fopen(DataFile, "r");
	fclose(fp);
	if (fp == NULL) {
		/*	Vt@C蒼āAׂďo	*/
		if (CharCount != 0) {
			fp = fopen(DataFile, "w");
			if (fp == NULL)
				return 1;
			for (int i = 0; i < CharCount; i++) {
				if (CHR[i]->fOut(fp) != 0) {
					fclose(fp);
					return 1;
				}
			}
			fclose(fp);
		}
	}
	else {
		/*	VǉꂽW`̂ݏo	*/
		if (LoadCount < CharCount) {
			fp = fopen(DataFile, "a");
			for (int i = LoadCount; i < CharCount; i++) {
				if (CHR[i]->fOut(fp) != 0) {
					fclose(fp);
					return 1;
				}
			}
			fclose(fp);
		}
	}
	return 0;
}


int LoadCHR(void)
{
	FILE *fp = fopen(DataFile, "r");
	if (fp == NULL)
		return 1;

	CharCount = -1;
	do {
		CharCount++;
		if (CharCount >= STD_CHAR_MAX)
			break;
		CHR[CharCount] = new CharData;
		if (CHR[CharCount] == NULL)
			return 2;
	} while (!CHR[CharCount]->fIn(fp));
	delete CHR[CharCount];
	LoadCount = CharCount;
	fclose(fp);
	return 0;
}


int matching(CHR_FEATURE data)
{
	int i, d, min_d = INT_MAX, min = -1;

	for (i = 0; i < CharCount; i++) {
		d = CHR[i]->comp(data);
		if (d < min_d) {
			min_d = d;
			min = i;
		}
	}

	if (min == -1)
		return -1;
	else
		return CHR[min]->Char();
}


int CharRegister(char ch, CHR_FEATURE data)
{
/*
	for (int i = 0; i < CharCount; i++) {
		if (ch == CHR[i]->Char()) {
			CHR[i]->setData(ch, data);
			return;
		}
	}
*/
	if (CharCount >= STD_CHAR_MAX)
		return 2;

	CHR[CharCount] = new CharData;
	CHR[CharCount]->setData(ch, data);
	CharCount++;
	return 0;
}


static int LineCheck(int sx, int sy, int ex, int ey)
{
	int x, y, flag = 0, count = 0, work;


	if (abs(ey - sy) > abs(ex - sx)) {
		if (sy == ey)
			return 0;
		if (sy > ey) {
			work = sx; sx = ex; ex = work;
			work = sy; sy = ey; ey = work;
		}

		for (y = sy; y <= ey; y++) {
			x = (int)(sx + (long)(y - sy) * (ex - sx) / (ey - sy));
			if (getpixel(x, y) == CHR_COLOR) {
				if (flag == 0) {
					count++;
					flag = 1;
				}
			}
			else {
#if !defined(NODEBUG)
				putpixel(x, y, RED);
#endif
				flag = 0;
			}
		}
	}
	else {
		if (sx == ex)
			return 0;
		if (sx > ex) {
			work = sx; sx = ex; ex = work;
			work = sy; sy = ey; ey = work;
		}
		for (x = sx; x <= ex; x++) {
			y = (int)(sy + (long)(x - sx) * (ey - sy) / (ex - sx));
			if (getpixel(x, y) == CHR_COLOR) {
				if (flag == 0) {
					count++;
					flag = 1;
				}
			}
			else {
#if !defined(NODEBUG)
				putpixel(x, y, RED);
#endif
				flag = 0;
			}
		}
	}
	return count;
}


static int BWHCheck(int sx, int y, int ex)
{
	int Xsize = ex - sx;
	int Lx, Rx, x;
	if (Xsize <= 0)
		return 0;
	Lx = ex;
	for (x = sx; x <= ex; x++) {
		if (getpixel(x, y) == CHR_COLOR) {
			Lx = x;
			break;
		}
	}
	Rx = Lx;
	for (x = ex; x >= Lx; x--) {
		if (getpixel(x, y) == CHR_COLOR) {
			Rx = x;
			break;
		}
	}
	return (Rx - Lx) * 3 / Xsize;
}


void MakeData(int sx, int sy, int ex, int ey, int TopY, int BottomY,
														CHR_FEATURE data)
{
	int i, px[5], py[5];
	for (i = 0; i < 5; i++) {
		px[i] = sx + (ex - sx) * i / 4;
		py[i] = sy + (ey - sy) * i / 4;
	}

#if !defined(NODEBUG)
	setcolor(BLUE);
	line(sx, sy, sx, ey);
	line(sx, ey, ex, ey);
	line(ex, ey, ex, sy);
	line(ex, sy, sx, sy);
	setcolor(CHR_COLOR);
#endif
	mouseoff();

	data[ 0] = LineCheck(px[1], py[0], px[1], py[4]);
	data[ 1] = LineCheck(px[2], py[0], px[2], py[4]);
	data[ 2] = LineCheck(px[3], py[0], px[3], py[4]);

	data[ 3] = LineCheck(px[0], py[1], px[4], py[1]);
	data[ 4] = LineCheck(px[0], py[2], px[4], py[2]);
	data[ 5] = LineCheck(px[0], py[3], px[4], py[3]);

	data[ 6] = LineCheck(px[0], py[0], px[4], py[4]);
	data[ 7] = LineCheck(px[0], py[4], px[4], py[0]);

	data[ 8] = LineCheck(px[2], py[0], px[0], py[2]);
	data[ 9] = LineCheck(px[0], py[2], px[2], py[4]);
	data[10] = LineCheck(px[2], py[0], px[4], py[2]);
	data[11] = LineCheck(px[4], py[2], px[2], py[4]);

	data[12] = LineCheck(px[1], py[0], px[0], py[1]);
	data[13] = LineCheck(px[0], py[3], px[1], py[4]);
	data[14] = LineCheck(px[3], py[0], px[4], py[1]);
	data[15] = LineCheck(px[4], py[3], px[3], py[4]);

	data[16] = LineCheck(px[1], py[0], px[4], py[3]);
	data[17] = LineCheck(px[0], py[1], px[3], py[4]);
	data[18] = LineCheck(px[3], py[0], px[0], py[3]);
	data[19] = LineCheck(px[4], py[1], px[1], py[4]);


	if (px[4] - px[0] <= 0)
		data[20] = 0;
	else
		data[20] = ((py[4] - py[0]) * 4) / (px[4] - px[0]);
	data[21] = ((py[4] - py[0]) * 4) / (BottomY - TopY);
	data[22] = ((BottomY - py[0]) * 4) / (BottomY - TopY);

	for (i = 0; i < 3; i++)
		data[23 + i] = BWHCheck(px[0], py[i + 1], px[4]);
	mouseon();
}




void GetFeature(int sx, int sy, int ex, int ey, CHR_FEATURE data)
{
	int x, y, x1, y1, x2, y2, flag;
	int Ysize = ey - sy;

	x1 = ex;
	y1 = ey;
	x2 = sx;
	y2 = sy;

	mouseoff();
	for (x = sx; x <= ex; x++) {
		for (y = sy; y <= ey; y++) {
			if (getpixel(x, y) == CHR_COLOR) {
				if (y < y1)
					y1 = y;
				if (x < x1)
					x1 = x;
				if (x > x2)
					x2 = x;
				break;
			}
		}
	}
	flag = 0;
	for (y = ey; flag == 0 && y >= y1; y--) {
		for (x = x1; x <= x2; x++) {
			if (getpixel(x, y) == CHR_COLOR) {
				flag = 1;
				y2 = y;
				break;
			}
		}
	}

	x1 -= Ysize / 20;
	y1 -= Ysize / 20;
	x2 += Ysize / 20;
	y2 += Ysize / 20;
	if (x1 < sx)
		x1 = sx;
	if (y1 < sy)
		y1 = sy;
	if (x2 > ex)
		x2 = ex;
	if (y2 > ey)
		y2 = ey;
	mouseon();
	MakeData(x1, y1, x2, y2, sy, ey, data);
}



void ImageToStr(int sx, int sy, int ex, int ey, char *str)
{
	CHR_FEATURE feature;
	int Ysize = ey - sy;
	int x, y, x1, x2;

	x1 = -1;
	x2 = sx;
	for (x = sx; x <= ex; x += 3) {
		for (y = sy; y <= ey; y += 3) {
			if (getpixel(x, y) == CHR_COLOR) {
				if (x1 == -1) {
					x1 = x;
					x2 = x;
				}
				else
					x2 = x;
				break;
			}
		}
		if ((x1 != -1) && (x2 < x - (Ysize / 10))) {
			int GFx1 = x1 - (3 + Ysize / 20);
			if (GFx1 < sx)
				GFx1 = sx;
			int GFx2 = x2 + (3 + Ysize / 20);
			if (GFx2 > ex)
				GFx2 = ex;
			GetFeature(GFx1, sy, GFx2, ey, feature);
			*str = matching(feature);
			if (*str != -1)
				str++;
			x1 = -1;
		}
		if (x2 < (x - (Ysize * 2 / 5))) {
			*str = ' ';
			str++;
			x2 = x;
		}
	}
	if (x1 != -1) {
		int GFx1 = x1 - (3+Ysize/20);
		if (GFx1 < sx)
			GFx1 = sx;
		int GFx2 = x2 + (3+Ysize/20);
		if (GFx2 > ex)
			GFx2 = ex;
		GetFeature(GFx1, sy, GFx2, ey, feature);
		*str = matching(feature);
		str++;
		x1 = -1;
	}
	*str = '\0';
}


/*  Copyright(C) 1994 a  */
